// example - demonstrating the graphql and expressjs

let express = require("express");

// step1 - importing functions for building the application
let { buildSchema } = require("graphql");
let { graphqlHTTP } = require("express-graphql");

// step2 - type definition

// schema wraps up all build definitions
let schema = buildSchema(`
  type Query {
    message: String
  }
`);

// step3 - resolver
let rootValue = {
  message: () => {
    return "Hello world!";
  }
};

let app = express();

// url - http://localhost:3005/graphql
app.use(
  "/graphql",
  graphqlHTTP({
    schema,
    rootValue,
    graphiql: true
  })
);

// driver code
const port = 3005;
app.listen(port, () => {
  console.log(`Application listening on port ${port}`);
});
